T=6
tsname="joMatrixCons"
@testset "$tsname" begin
for t=1:T # start test loop

    if t<=2
        (m,n)=(5,5)
    else
        (m,n)=(rand(3:7),rand(3:7))
    end

    if t%2==1
        tname="loop $t for real($m,$n)"
        a=rand()
        v=rand(n)
    else
        tname="loop $t for complex($m,$n)"
        a=rand(ComplexF64)
        v=rand(ComplexF64,n)
    end

    verbose && println("$tsname $tname")
    @testset "$m x $n" begin

    @test norm(elements(joZeros(m,n))-zeros(m,n)) < joTol
    @test norm(elements(transpose(joZeros(m,n)))-transpose(zeros(m,n))) < joTol
    @test norm(elements(adjoint(joZeros(m,n)))-adjoint(zeros(m,n))) < joTol
    @test norm(elements(conj(joZeros(m,n)))-conj(zeros(m,n))) < joTol

    @test norm(elements(joOnes(m,n))-ones(m,n)) < joTol
    @test norm(elements(transpose(joOnes(m,n)))-transpose(ones(m,n))) < joTol
    @test norm(elements(adjoint(joOnes(m,n)))-adjoint(ones(m,n))) < joTol
    @test norm(elements(conj(joOnes(m,n)))-conj(ones(m,n))) < joTol

    @test norm(elements(joConstants(m,n,a))-(a*ones(m,n))) < joTol
    @test norm(elements(transpose(joConstants(m,n,a)))-transpose(a*ones(m,n))) < joTol
    @test norm(elements(adjoint(joConstants(m,n,a)))-adjoint(a*ones(m,n))) < joTol
    @test norm(elements(conj(joConstants(m,n,a)))-(conj(a*ones(m,n)))) < joTol

    @test norm(elements(joDirac(m))-jo_eye(m)) < joTol
    @test norm(elements(transpose(joDirac(m)))-transpose(jo_eye(m))) < joTol
    @test norm(elements(adjoint(joDirac(m)))-adjoint(jo_eye(m))) < joTol
    @test norm(elements(conj(joDirac(m)))-conj(jo_eye(m))) < joTol

    @test norm(elements(joEye(m,n))-jo_eye(m,n)) < joTol
    @test norm(elements(transpose(joEye(m,n)))-transpose(jo_eye(m,n))) < joTol
    @test norm(elements(adjoint(joEye(m,n)))-adjoint(jo_eye(m,n))) < joTol
    @test norm(elements(conj(joEye(m,n)))-conj(jo_eye(m,n))) < joTol

    @test norm(elements(joDiag(v))-diagm(0=>v)) < joTol
    @test norm(elements(transpose(joDiag(v)))-transpose(diagm(0=>v))) < joTol
    @test norm(elements(adjoint(joDiag(v)))-adjoint(diagm(0=>v))) < joTol
    @test norm(elements(conj(joDiag(v)))-conj(diagm(0=>v))) < joTol

    #joVecConvert.jl
    if t%2==0

        @test norm(joReal(n)*v-real(v)) < joTol
        @test norm(transpose(joReal(n))*real(v)-complex.(real(v))) < joTol
        @test norm(adjoint(joReal(n))*real(v)-complex.(real(v))) < joTol
        @test norm(conj(joReal(n))*v-real(v)) < joTol

        @test norm(joImag(n)*v-imag(v)) < joTol
        @test norm(transpose(joImag(n))*imag(v)-complex.(0.,imag(v))) < joTol
        @test norm(adjoint(joImag(n))*imag(v)-complex.(0.,-imag(v))) < joTol
        @test norm(conj(joImag(n))*v-imag(-v)) < joTol

        @test norm(joConj(n)*v-conj(v)) < joTol
        @test norm(transpose(joConj(n))*v-conj(v)) < joTol
        @test norm(adjoint(joConj(n))*v-conj(v)) < joTol
        @test norm(conj(joConj(n))*v-conj(v)) < joTol

    end

    end

end # end test loop
end
